--- a/nss/lib/ckfw/builtins/certdata.txt
+++ b/nss/lib/ckfw/builtins/certdata.txt
@@ -21704,3 +21704,391 @@ CKA_TRUST_SERVER_AUTH CK_TRUST CKT_NSS_TRUSTED_DELEGATOR
 CKA_TRUST_EMAIL_PROTECTION CK_TRUST CKT_NSS_MUST_VERIFY_TRUST
 CKA_TRUST_CODE_SIGNING CK_TRUST CKT_NSS_MUST_VERIFY_TRUST
 CKA_TRUST_STEP_UP_APPROVED CK_BBOOL CK_FALSE
+
+#
+# Certificate "CA Cert Signing Authority"
+#
+# Issuer: E=support@cacert.org,CN=CA Cert Signing Authority,OU=http://www.cacert.org,O=Root CA
+# Serial Number: 15 (0xf)
+# Subject: E=support@cacert.org,CN=CA Cert Signing Authority,OU=http://www.cacert.org,O=Root CA
+# Not Valid Before: Sun Mar 30 12:29:49 2003
+# Not Valid After : Tue Mar 29 12:29:49 2033
+# Fingerprint (SHA-256): 07:ED:BD:82:4A:49:88:CF:EF:42:15:DA:20:D4:8C:2B:41:D7:15:29:D7:C9:00:F5:70:92:6F:27:7C:C2:30:C5
+# Fingerprint (SHA1): DD:FC:DA:54:1E:75:77:AD:DC:A8:7E:88:27:A9:8A:50:60:32:52:A5
+CKA_CLASS CK_OBJECT_CLASS CKO_CERTIFICATE
+CKA_TOKEN CK_BBOOL CK_TRUE
+CKA_PRIVATE CK_BBOOL CK_FALSE
+CKA_MODIFIABLE CK_BBOOL CK_FALSE
+CKA_LABEL UTF8 "CA Cert Signing Authority"
+CKA_CERTIFICATE_TYPE CK_CERTIFICATE_TYPE CKC_X_509
+CKA_SUBJECT MULTILINE_OCTAL
+\060\171\061\020\060\016\006\003\125\004\012\023\007\122\157\157
+\164\040\103\101\061\036\060\034\006\003\125\004\013\023\025\150
+\164\164\160\072\057\057\167\167\167\056\143\141\143\145\162\164
+\056\157\162\147\061\042\060\040\006\003\125\004\003\023\031\103
+\101\040\103\145\162\164\040\123\151\147\156\151\156\147\040\101
+\165\164\150\157\162\151\164\171\061\041\060\037\006\011\052\206
+\110\206\367\015\001\011\001\026\022\163\165\160\160\157\162\164
+\100\143\141\143\145\162\164\056\157\162\147
+END
+CKA_ID UTF8 "0"
+CKA_ISSUER MULTILINE_OCTAL
+\060\171\061\020\060\016\006\003\125\004\012\023\007\122\157\157
+\164\040\103\101\061\036\060\034\006\003\125\004\013\023\025\150
+\164\164\160\072\057\057\167\167\167\056\143\141\143\145\162\164
+\056\157\162\147\061\042\060\040\006\003\125\004\003\023\031\103
+\101\040\103\145\162\164\040\123\151\147\156\151\156\147\040\101
+\165\164\150\157\162\151\164\171\061\041\060\037\006\011\052\206
+\110\206\367\015\001\011\001\026\022\163\165\160\160\157\162\164
+\100\143\141\143\145\162\164\056\157\162\147
+END
+CKA_SERIAL_NUMBER MULTILINE_OCTAL
+\002\001\017
+END
+CKA_VALUE MULTILINE_OCTAL
+\060\202\006\356\060\202\004\326\240\003\002\001\002\002\001\017
+\060\015\006\011\052\206\110\206\367\015\001\001\013\005\000\060
+\171\061\020\060\016\006\003\125\004\012\023\007\122\157\157\164
+\040\103\101\061\036\060\034\006\003\125\004\013\023\025\150\164
+\164\160\072\057\057\167\167\167\056\143\141\143\145\162\164\056
+\157\162\147\061\042\060\040\006\003\125\004\003\023\031\103\101
+\040\103\145\162\164\040\123\151\147\156\151\156\147\040\101\165
+\164\150\157\162\151\164\171\061\041\060\037\006\011\052\206\110
+\206\367\015\001\011\001\026\022\163\165\160\160\157\162\164\100
+\143\141\143\145\162\164\056\157\162\147\060\036\027\015\060\063
+\060\063\063\060\061\062\062\071\064\071\132\027\015\063\063\060
+\063\062\071\061\062\062\071\064\071\132\060\171\061\020\060\016
+\006\003\125\004\012\023\007\122\157\157\164\040\103\101\061\036
+\060\034\006\003\125\004\013\023\025\150\164\164\160\072\057\057
+\167\167\167\056\143\141\143\145\162\164\056\157\162\147\061\042
+\060\040\006\003\125\004\003\023\031\103\101\040\103\145\162\164
+\040\123\151\147\156\151\156\147\040\101\165\164\150\157\162\151
+\164\171\061\041\060\037\006\011\052\206\110\206\367\015\001\011
+\001\026\022\163\165\160\160\157\162\164\100\143\141\143\145\162
+\164\056\157\162\147\060\202\002\042\060\015\006\011\052\206\110
+\206\367\015\001\001\001\005\000\003\202\002\017\000\060\202\002
+\012\002\202\002\001\000\316\042\300\342\106\175\354\066\050\007
+\120\226\362\240\063\100\214\113\361\073\146\077\061\345\153\002
+\066\333\326\174\366\361\210\217\116\167\066\005\101\225\371\011
+\360\022\317\106\206\163\140\267\156\176\350\300\130\144\256\315
+\260\255\105\027\014\143\372\147\012\350\326\322\277\076\347\230
+\304\360\114\372\340\003\273\065\135\154\041\336\236\040\331\272
+\315\146\062\067\162\372\367\010\365\307\315\130\311\216\347\016
+\136\352\076\376\034\241\024\012\025\154\206\204\133\144\146\052
+\172\251\113\123\171\365\210\242\173\356\057\012\141\053\215\262
+\176\115\126\245\023\354\352\332\222\236\254\104\101\036\130\140
+\145\005\146\370\300\104\275\313\224\367\102\176\013\367\145\150
+\230\121\005\360\363\005\221\004\035\033\027\202\354\310\127\273
+\303\153\172\210\361\260\162\314\045\133\040\221\354\026\002\022
+\217\062\351\027\030\110\320\307\005\056\002\060\102\270\045\234
+\005\153\077\252\072\247\353\123\110\367\350\322\266\007\230\334
+\033\306\064\177\177\311\034\202\172\005\130\053\010\133\363\070
+\242\253\027\135\146\311\230\327\236\020\213\242\322\335\164\232
+\367\161\014\162\140\337\315\157\230\063\235\226\064\166\076\044
+\172\222\260\016\225\036\157\346\240\105\070\107\252\327\101\355
+\112\267\022\366\327\033\203\212\017\056\330\011\266\131\327\252
+\004\377\322\223\175\150\056\335\213\113\253\130\272\057\215\352
+\225\247\240\303\124\211\245\373\333\213\121\042\235\262\303\276
+\021\276\054\221\206\213\226\170\255\040\323\212\057\032\077\306
+\320\121\145\207\041\261\031\001\145\177\105\034\207\365\174\320
+\101\114\117\051\230\041\375\063\037\165\014\004\121\372\031\167
+\333\324\024\034\356\201\303\035\365\230\267\151\006\221\042\335
+\000\120\314\201\061\254\022\007\173\070\332\150\133\346\053\324
+\176\311\137\255\350\353\162\114\363\001\345\113\040\277\232\246
+\127\312\221\000\001\213\241\165\041\067\265\143\015\147\076\106
+\117\160\040\147\316\305\326\131\333\002\340\360\322\313\315\272
+\142\267\220\101\350\335\040\344\051\274\144\051\102\310\042\334
+\170\232\377\103\354\230\033\011\121\113\132\132\302\161\361\304
+\313\163\251\345\241\013\002\003\001\000\001\243\202\001\177\060
+\202\001\173\060\035\006\003\125\035\016\004\026\004\024\026\265
+\062\033\324\307\363\340\346\216\363\275\322\260\072\356\262\071
+\030\321\060\017\006\003\125\035\023\001\001\377\004\005\060\003
+\001\001\377\060\064\006\011\140\206\110\001\206\370\102\001\010
+\004\047\026\045\150\164\164\160\072\057\057\167\167\167\056\143
+\141\143\145\162\164\056\157\162\147\057\151\156\144\145\170\056
+\160\150\160\077\151\144\075\061\060\060\126\006\011\140\206\110
+\001\206\370\102\001\015\004\111\026\107\124\157\040\147\145\164
+\040\171\157\165\162\040\157\167\156\040\143\145\162\164\151\146
+\151\143\141\164\145\040\146\157\162\040\106\122\105\105\040\150
+\145\141\144\040\157\166\145\162\040\164\157\040\150\164\164\160
+\072\057\057\167\167\167\056\143\141\143\145\162\164\056\157\162
+\147\060\061\006\003\125\035\037\004\052\060\050\060\046\240\044
+\240\042\206\040\150\164\164\160\072\057\057\143\162\154\056\143
+\141\143\145\162\164\056\157\162\147\057\162\145\166\157\153\145
+\056\143\162\154\060\063\006\011\140\206\110\001\206\370\102\001
+\004\004\046\026\044\125\122\111\072\150\164\164\160\072\057\057
+\143\162\154\056\143\141\143\145\162\164\056\157\162\147\057\162
+\145\166\157\153\145\056\143\162\154\060\062\006\010\053\006\001
+\005\005\007\001\001\004\046\060\044\060\042\006\010\053\006\001
+\005\005\007\060\001\206\026\150\164\164\160\072\057\057\157\143
+\163\160\056\143\141\143\145\162\164\056\157\162\147\060\037\006
+\003\125\035\043\004\030\060\026\200\024\026\265\062\033\324\307
+\363\340\346\216\363\275\322\260\072\356\262\071\030\321\060\015
+\006\011\052\206\110\206\367\015\001\001\013\005\000\003\202\002
+\001\000\107\234\327\263\242\027\323\122\123\267\264\152\335\277
+\233\065\025\041\154\357\157\030\023\040\201\314\350\355\035\052
+\042\035\144\166\024\272\133\067\053\016\203\272\076\112\156\106
+\015\013\336\243\073\141\000\172\247\015\225\372\346\363\027\274
+\145\340\055\007\132\133\137\314\364\333\314\001\335\046\330\332
+\045\014\073\101\240\145\230\006\051\067\140\213\007\242\136\203
+\312\277\325\172\140\167\017\376\040\375\106\107\007\140\357\025
+\051\105\345\000\343\315\245\340\301\365\221\375\026\321\247\175
+\341\053\210\174\325\220\035\307\113\002\231\247\243\364\224\207
+\126\351\147\047\226\254\311\345\206\101\215\014\243\061\010\044
+\027\103\176\264\117\001\107\163\307\137\020\006\252\346\274\272
+\161\234\346\326\207\255\256\104\257\210\115\252\241\374\157\277
+\125\105\211\017\275\115\175\377\316\101\002\012\305\001\374\110
+\317\063\111\161\024\031\256\365\076\110\207\341\052\236\317\142
+\276\152\304\041\000\357\366\323\162\044\173\213\260\063\152\155
+\100\132\227\263\250\210\366\147\136\117\113\037\352\233\372\222
+\337\326\207\357\346\172\062\346\365\366\153\223\212\171\261\336
+\373\101\061\374\016\336\370\157\307\270\350\325\066\250\131\366
+\076\115\212\312\137\253\334\315\310\341\306\130\077\050\176\077
+\003\037\000\171\320\275\127\207\221\376\021\262\050\201\257\341
+\044\044\047\106\334\126\220\163\372\367\324\365\046\222\305\143
+\006\251\202\231\142\274\136\023\026\376\037\252\235\047\035\062
+\202\327\037\140\032\262\040\276\346\011\227\133\161\040\251\261
+\135\327\311\316\013\034\063\072\251\151\270\155\034\343\027\072
+\054\020\006\225\263\310\231\050\174\137\360\347\227\264\056\333
+\131\014\031\004\262\051\125\376\365\264\010\233\017\263\167\215
+\151\001\176\210\305\254\160\143\244\200\261\145\132\300\022\334
+\174\062\211\202\315\046\215\272\152\254\226\075\242\035\163\301
+\070\162\116\322\223\117\026\254\132\307\040\255\304\036\276\047
+\324\126\160\230\272\105\002\373\234\052\250\045\322\032\376\332
+\074\251\312\036\151\270\015\312\222\301\305\334\053\024\316\063
+\024\277\074\114\207\051\041\367\072\314\305\000\007\054\025\153
+\033\007
+END
+CKA_NSS_MOZILLA_CA_POLICY CK_BBOOL CK_TRUE
+CKA_NSS_SERVER_DISTRUST_AFTER CK_BBOOL CK_FALSE
+CKA_NSS_EMAIL_DISTRUST_AFTER CK_BBOOL CK_FALSE
+
+# Trust for "CA Cert Signing Authority"
+# Issuer: E=support@cacert.org,CN=CA Cert Signing Authority,OU=http://www.cacert.org,O=Root CA
+# Serial Number: 15 (0xf)
+# Subject: E=support@cacert.org,CN=CA Cert Signing Authority,OU=http://www.cacert.org,O=Root CA
+# Not Valid Before: Sun Mar 30 12:29:49 2003
+# Not Valid After : Tue Mar 29 12:29:49 2033
+# Fingerprint (SHA-256): 07:ED:BD:82:4A:49:88:CF:EF:42:15:DA:20:D4:8C:2B:41:D7:15:29:D7:C9:00:F5:70:92:6F:27:7C:C2:30:C5
+# Fingerprint (SHA1): DD:FC:DA:54:1E:75:77:AD:DC:A8:7E:88:27:A9:8A:50:60:32:52:A5
+CKA_CLASS CK_OBJECT_CLASS CKO_NSS_TRUST
+CKA_TOKEN CK_BBOOL CK_TRUE
+CKA_PRIVATE CK_BBOOL CK_FALSE
+CKA_MODIFIABLE CK_BBOOL CK_FALSE
+CKA_LABEL UTF8 "CA Cert Signing Authority"
+CKA_CERT_SHA1_HASH MULTILINE_OCTAL
+\335\374\332\124\036\165\167\255\334\250\176\210\047\251\212\120
+\140\062\122\245
+END
+CKA_CERT_MD5_HASH MULTILINE_OCTAL
+\212\346\033\032\367\147\232\220\225\247\351\340\055\377\037\363
+END
+CKA_ISSUER MULTILINE_OCTAL
+\060\171\061\020\060\016\006\003\125\004\012\023\007\122\157\157
+\164\040\103\101\061\036\060\034\006\003\125\004\013\023\025\150
+\164\164\160\072\057\057\167\167\167\056\143\141\143\145\162\164
+\056\157\162\147\061\042\060\040\006\003\125\004\003\023\031\103
+\101\040\103\145\162\164\040\123\151\147\156\151\156\147\040\101
+\165\164\150\157\162\151\164\171\061\041\060\037\006\011\052\206
+\110\206\367\015\001\011\001\026\022\163\165\160\160\157\162\164
+\100\143\141\143\145\162\164\056\157\162\147
+END
+CKA_SERIAL_NUMBER MULTILINE_OCTAL
+\002\001\017
+END
+CKA_TRUST_SERVER_AUTH CK_TRUST CKT_NSS_TRUSTED_DELEGATOR
+CKA_TRUST_EMAIL_PROTECTION CK_TRUST CKT_NSS_TRUSTED_DELEGATOR
+CKA_TRUST_CODE_SIGNING CK_TRUST CKT_NSS_TRUSTED_DELEGATOR
+CKA_TRUST_STEP_UP_APPROVED CK_BBOOL CK_FALSE
+
+#
+# Certificate "CAcert Class 3 Root"
+#
+# Issuer: E=support@cacert.org,CN=CA Cert Signing Authority,OU=http://www.cacert.org,O=Root CA
+# Serial Number: 14 (0xe)
+# Subject: CN=CAcert Class 3 Root,OU=http://www.CAcert.org,O=CAcert Inc.
+# Not Valid Before: Mon May 23 17:48:02 2011
+# Not Valid After : Thu May 20 17:48:02 2021
+# Fingerprint (SHA-256): F6:87:3D:70:D6:75:96:C2:AC:BA:34:40:1E:69:73:8B:52:70:1D:D6:AB:06:B4:97:49:BC:55:15:09:36:D5:44
+# Fingerprint (SHA1): A7:C4:8F:BE:6B:02:6D:BD:0E:C1:B4:65:B8:8D:D8:13:EE:1D:EF:A0
+CKA_CLASS CK_OBJECT_CLASS CKO_CERTIFICATE
+CKA_TOKEN CK_BBOOL CK_TRUE
+CKA_PRIVATE CK_BBOOL CK_FALSE
+CKA_MODIFIABLE CK_BBOOL CK_FALSE
+CKA_LABEL UTF8 "CAcert Class 3 Root"
+CKA_CERTIFICATE_TYPE CK_CERTIFICATE_TYPE CKC_X_509
+CKA_SUBJECT MULTILINE_OCTAL
+\060\124\061\024\060\022\006\003\125\004\012\023\013\103\101\143
+\145\162\164\040\111\156\143\056\061\036\060\034\006\003\125\004
+\013\023\025\150\164\164\160\072\057\057\167\167\167\056\103\101
+\143\145\162\164\056\157\162\147\061\034\060\032\006\003\125\004
+\003\023\023\103\101\143\145\162\164\040\103\154\141\163\163\040
+\063\040\122\157\157\164
+END
+CKA_ID UTF8 "0"
+CKA_ISSUER MULTILINE_OCTAL
+\060\171\061\020\060\016\006\003\125\004\012\023\007\122\157\157
+\164\040\103\101\061\036\060\034\006\003\125\004\013\023\025\150
+\164\164\160\072\057\057\167\167\167\056\143\141\143\145\162\164
+\056\157\162\147\061\042\060\040\006\003\125\004\003\023\031\103
+\101\040\103\145\162\164\040\123\151\147\156\151\156\147\040\101
+\165\164\150\157\162\151\164\171\061\041\060\037\006\011\052\206
+\110\206\367\015\001\011\001\026\022\163\165\160\160\157\162\164
+\100\143\141\143\145\162\164\056\157\162\147
+END
+CKA_SERIAL_NUMBER MULTILINE_OCTAL
+\002\001\016
+END
+CKA_VALUE MULTILINE_OCTAL
+\060\202\006\322\060\202\004\272\240\003\002\001\002\002\001\016
+\060\015\006\011\052\206\110\206\367\015\001\001\013\005\000\060
+\171\061\020\060\016\006\003\125\004\012\023\007\122\157\157\164
+\040\103\101\061\036\060\034\006\003\125\004\013\023\025\150\164
+\164\160\072\057\057\167\167\167\056\143\141\143\145\162\164\056
+\157\162\147\061\042\060\040\006\003\125\004\003\023\031\103\101
+\040\103\145\162\164\040\123\151\147\156\151\156\147\040\101\165
+\164\150\157\162\151\164\171\061\041\060\037\006\011\052\206\110
+\206\367\015\001\011\001\026\022\163\165\160\160\157\162\164\100
+\143\141\143\145\162\164\056\157\162\147\060\036\027\015\061\061
+\060\065\062\063\061\067\064\070\060\062\132\027\015\062\061\060
+\065\062\060\061\067\064\070\060\062\132\060\124\061\024\060\022
+\006\003\125\004\012\023\013\103\101\143\145\162\164\040\111\156
+\143\056\061\036\060\034\006\003\125\004\013\023\025\150\164\164
+\160\072\057\057\167\167\167\056\103\101\143\145\162\164\056\157
+\162\147\061\034\060\032\006\003\125\004\003\023\023\103\101\143
+\145\162\164\040\103\154\141\163\163\040\063\040\122\157\157\164
+\060\202\002\042\060\015\006\011\052\206\110\206\367\015\001\001
+\001\005\000\003\202\002\017\000\060\202\002\012\002\202\002\001
+\000\253\111\065\021\110\174\322\046\176\123\224\317\103\251\335
+\050\327\102\052\213\363\207\170\031\130\174\017\236\332\211\175
+\341\373\353\162\220\015\164\241\226\144\253\237\240\044\231\163
+\332\342\125\166\307\027\173\365\004\254\106\270\303\276\177\144
+\215\020\154\044\363\141\234\300\362\220\372\121\346\365\151\001
+\143\303\017\126\342\112\102\317\342\104\214\045\050\250\305\171
+\011\175\106\271\212\363\351\363\064\051\010\105\344\034\237\313
+\224\004\034\201\250\024\263\230\145\304\103\354\116\202\215\011
+\321\275\252\133\215\222\320\354\336\220\305\177\012\302\343\353
+\346\061\132\136\164\076\227\063\131\350\303\003\075\140\063\277
+\367\321\157\107\304\315\356\142\203\122\156\056\010\232\244\331
+\025\030\221\246\205\222\107\260\256\110\353\155\267\041\354\205
+\032\150\162\065\253\377\360\020\135\300\364\224\247\152\325\073
+\222\176\114\220\005\176\223\301\054\213\244\216\142\164\025\161
+\156\013\161\003\352\257\025\070\232\324\322\005\162\157\214\371
+\053\353\132\162\045\371\071\106\343\162\033\076\004\303\144\047
+\042\020\052\212\117\130\247\003\255\276\264\056\023\355\135\252
+\110\327\325\175\324\052\173\134\372\106\004\120\344\314\016\102
+\133\214\355\333\362\317\374\226\223\340\333\021\066\124\142\064
+\070\217\014\140\233\073\227\126\070\255\363\322\133\213\240\133
+\352\116\226\270\174\327\325\240\206\160\100\323\221\051\267\242
+\074\255\365\214\273\317\032\222\212\344\064\173\300\330\154\137
+\351\012\302\303\247\040\232\132\337\054\135\122\134\272\107\325
+\233\357\044\050\160\070\040\057\325\177\051\300\262\101\003\150
+\222\314\340\234\314\227\113\105\357\072\020\012\253\160\072\230
+\225\160\255\065\261\352\205\053\244\034\200\041\061\251\256\140
+\172\200\046\110\000\270\001\300\223\143\125\042\221\074\126\347
+\257\333\072\045\363\217\061\124\352\046\213\201\131\371\241\321
+\123\021\305\173\235\003\366\164\021\340\155\261\054\077\054\206
+\221\231\161\232\246\167\213\064\140\321\024\264\054\254\235\257
+\214\020\323\237\304\152\370\157\023\374\163\131\367\146\102\164
+\036\212\343\370\334\322\157\230\234\313\107\230\225\100\005\373
+\351\002\003\001\000\001\243\202\001\210\060\202\001\204\060\035
+\006\003\125\035\016\004\026\004\024\165\250\161\140\114\210\023
+\360\170\331\211\167\265\155\305\211\337\274\261\172\060\017\006
+\003\125\035\023\001\001\377\004\005\060\003\001\001\377\060\135
+\006\010\053\006\001\005\005\007\001\001\004\121\060\117\060\043
+\006\010\053\006\001\005\005\007\060\001\206\027\150\164\164\160
+\072\057\057\157\143\163\160\056\103\101\143\145\162\164\056\157
+\162\147\057\060\050\006\010\053\006\001\005\005\007\060\002\206
+\034\150\164\164\160\072\057\057\167\167\167\056\103\101\143\145
+\162\164\056\157\162\147\057\143\141\056\143\162\164\060\112\006
+\003\125\035\040\004\103\060\101\060\077\006\010\053\006\001\004
+\001\201\220\112\060\063\060\061\006\010\053\006\001\005\005\007
+\002\001\026\045\150\164\164\160\072\057\057\167\167\167\056\103
+\101\143\145\162\164\056\157\162\147\057\151\156\144\145\170\056
+\160\150\160\077\151\144\075\061\060\060\064\006\011\140\206\110
+\001\206\370\102\001\010\004\047\026\045\150\164\164\160\072\057
+\057\167\167\167\056\103\101\143\145\162\164\056\157\162\147\057
+\151\156\144\145\170\056\160\150\160\077\151\144\075\061\060\060
+\120\006\011\140\206\110\001\206\370\102\001\015\004\103\026\101
+\124\157\040\147\145\164\040\171\157\165\162\040\157\167\156\040
+\143\145\162\164\151\146\151\143\141\164\145\040\146\157\162\040
+\106\122\105\105\054\040\147\157\040\164\157\040\150\164\164\160
+\072\057\057\167\167\167\056\103\101\143\145\162\164\056\157\162
+\147\060\037\006\003\125\035\043\004\030\060\026\200\024\026\265
+\062\033\324\307\363\340\346\216\363\275\322\260\072\356\262\071
+\030\321\060\015\006\011\052\206\110\206\367\015\001\001\013\005
+\000\003\202\002\001\000\132\220\026\320\066\043\126\144\225\211
+\274\217\254\244\040\311\046\212\251\363\124\344\100\030\077\112
+\313\103\306\233\166\011\346\312\124\247\214\224\013\222\150\326
+\131\273\027\227\173\151\352\255\324\114\341\051\133\050\025\217
+\335\031\364\225\131\047\227\030\333\217\011\271\175\170\172\310
+\260\102\126\265\352\353\136\261\046\320\227\023\276\005\034\206
+\341\064\005\025\261\006\275\332\074\320\023\143\204\155\065\224
+\320\076\231\202\030\241\372\077\234\067\107\205\212\340\356\163
+\170\202\324\153\231\061\277\331\303\155\100\135\271\025\307\066
+\170\212\226\213\321\204\040\261\053\165\077\155\242\245\276\275
+\350\342\344\255\104\134\266\006\066\160\164\270\244\216\266\126
+\224\140\223\002\177\057\015\247\370\057\157\266\351\050\314\310
+\153\224\364\223\003\103\241\064\101\242\032\235\241\106\225\232
+\206\041\276\034\147\010\141\360\025\366\376\350\203\167\116\365
+\071\322\321\160\333\156\115\121\251\163\351\163\360\355\254\225
+\263\231\223\164\073\202\210\307\103\255\054\222\126\033\334\351
+\364\232\311\310\356\224\110\201\130\201\252\364\123\301\307\036
+\204\334\162\330\176\362\362\142\257\076\300\303\200\345\012\350
+\350\333\263\250\042\113\040\334\354\340\137\360\344\275\146\045
+\320\237\004\062\125\350\037\110\223\277\172\234\256\204\010\264
+\345\005\262\010\245\156\064\133\153\316\220\346\102\341\234\054
+\143\165\155\202\155\263\122\247\313\345\146\175\056\027\027\174
+\262\234\120\161\173\064\010\211\365\366\353\334\100\212\070\147
+\213\220\373\115\013\203\334\110\365\201\125\365\055\214\155\046
+\247\224\325\045\275\260\170\122\361\344\172\135\051\351\261\255
+\002\152\165\164\220\122\221\223\205\233\106\172\172\117\206\357
+\016\321\325\244\342\176\061\211\255\334\064\337\143\276\124\202
+\260\012\013\274\015\333\044\107\114\064\007\257\062\165\231\364
+\001\071\314\236\276\104\306\367\026\221\220\155\012\004\032\330
+\333\322\052\267\020\236\126\252\243\330\234\020\136\027\172\362
+\077\125\067\263\225\275\113\215\203\026\035\127\171\107\240\266
+\247\214\023\311\120\110\063\310\143\254\267\012\210\050\105\343
+\161\221\046\331\336\357
+END
+CKA_NSS_MOZILLA_CA_POLICY CK_BBOOL CK_TRUE
+CKA_NSS_SERVER_DISTRUST_AFTER CK_BBOOL CK_FALSE
+CKA_NSS_EMAIL_DISTRUST_AFTER CK_BBOOL CK_FALSE
+
+# Trust for "CAcert Class 3 Root"
+# Issuer: E=support@cacert.org,CN=CA Cert Signing Authority,OU=http://www.cacert.org,O=Root CA
+# Serial Number: 14 (0xe)
+# Subject: CN=CAcert Class 3 Root,OU=http://www.CAcert.org,O=CAcert Inc.
+# Not Valid Before: Mon May 23 17:48:02 2011
+# Not Valid After : Thu May 20 17:48:02 2021
+# Fingerprint (SHA-256): F6:87:3D:70:D6:75:96:C2:AC:BA:34:40:1E:69:73:8B:52:70:1D:D6:AB:06:B4:97:49:BC:55:15:09:36:D5:44
+# Fingerprint (SHA1): A7:C4:8F:BE:6B:02:6D:BD:0E:C1:B4:65:B8:8D:D8:13:EE:1D:EF:A0
+CKA_CLASS CK_OBJECT_CLASS CKO_NSS_TRUST
+CKA_TOKEN CK_BBOOL CK_TRUE
+CKA_PRIVATE CK_BBOOL CK_FALSE
+CKA_MODIFIABLE CK_BBOOL CK_FALSE
+CKA_LABEL UTF8 "CAcert Class 3 Root"
+CKA_CERT_SHA1_HASH MULTILINE_OCTAL
+\247\304\217\276\153\002\155\275\016\301\264\145\270\215\330\023
+\356\035\357\240
+END
+CKA_CERT_MD5_HASH MULTILINE_OCTAL
+\054\372\077\371\364\112\012\155\077\127\176\250\250\043\025\276
+END
+CKA_ISSUER MULTILINE_OCTAL
+\060\171\061\020\060\016\006\003\125\004\012\023\007\122\157\157
+\164\040\103\101\061\036\060\034\006\003\125\004\013\023\025\150
+\164\164\160\072\057\057\167\167\167\056\143\141\143\145\162\164
+\056\157\162\147\061\042\060\040\006\003\125\004\003\023\031\103
+\101\040\103\145\162\164\040\123\151\147\156\151\156\147\040\101
+\165\164\150\157\162\151\164\171\061\041\060\037\006\011\052\206
+\110\206\367\015\001\011\001\026\022\163\165\160\160\157\162\164
+\100\143\141\143\145\162\164\056\157\162\147
+END
+CKA_SERIAL_NUMBER MULTILINE_OCTAL
+\002\001\016
+END
+CKA_TRUST_SERVER_AUTH CK_TRUST CKT_NSS_TRUSTED_DELEGATOR
+CKA_TRUST_EMAIL_PROTECTION CK_TRUST CKT_NSS_TRUSTED_DELEGATOR
+CKA_TRUST_CODE_SIGNING CK_TRUST CKT_NSS_TRUSTED_DELEGATOR
+CKA_TRUST_STEP_UP_APPROVED CK_BBOOL CK_FALSE
 